from subprocess import Popen, PIPE
import requests
import socket
import requests.packages.urllib3.util.connection as urllib3_cn
 
def allowed_gai_family():
    family = socket.AF_INET    # force IPv4
    return family
 
urllib3_cn.allowed_gai_family = allowed_gai_family

ANACONDA = '4.10.3'

FILES = {
    '__init__.py' : ['https://git.ik.bme.hu/joker/joker/raw/script/upgrade/files/__init__.py', 'lib/python3.8/site-packages/slurm_jupyter/'],
}

def anaconda():
    with Popen('conda --version', stdout=PIPE, stderr=PIPE, shell=True) as proc:
        (outdata, errdata) = proc.communicate()
        if errdata.decode('UTF-8') != '':
            return False
        ver = outdata.decode('UTF-8').split()
        print(f'\tJelenlegi verzió: {ver[1]}')
        print(f'\tAjánlott verzió: {ANACONDA}')
        return ver[1] == ANACONDA

def path():
    with Popen('conda info', stdout=PIPE, stderr=PIPE, shell=True) as proc:
        (outdata, errdata) = proc.communicate()
        if errdata.decode('UTF-8') != '':
            return False, ''
        path = outdata.decode('UTF-8').split("\n")[2]
        path = path.split(":")[1].split()[0]
        return True, path

def getFile(dir, name):
    print(f'\tLetöltés: {FILES[name][0]}')
    print(f'\tA fájl ide kerül: {dir}/{FILES[name][1]}{name}')
    headers = {"User-Agent": "Mozilla/5.0 (X11; CrOS x86_64 12871.102.0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/81.0.4044.141 Safari/537.36"}
    req = requests.get(FILES[name][0], stream=True, headers=headers)
    print('\t', end =" ")
    with open(f'{dir}/{FILES[name][1]}{name}', 'wb') as f:
        for chunk in req.iter_content(chunk_size=256):
            if chunk:
                    f.write(chunk)
                    print('.', end =" ")
    print('\n\tOK\n')

def files(dir):
    print('Fájlok letöltése')
    getFile(dir, '__init__.py')

def upgrade():
    print('Anaconda könyvtár keresése')
    ok, dir = path()
    if ok:
        print(f'\tKiolvasott útvonal: {dir}')
    else:
        print('\tNem tudtam útvonalat kiolvasni, adja meg: ')
        dir = input()
        print('Megpróbálom ezzel ...')
    files(dir)
    

if __name__ == '__main__':
    print("Anaconda vizsgálata ...")
    if anaconda():
        print('OK\n')
        upgrade()
    else:
        print('Valami baj lehet! Folytatja (i/n) ?')
        ok = input()
        if ok == 'i' or ok == 'I':
            upgrade()
